#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#define F_CPU 16000000


#define speed 100
#define max_speed 255


#define DDR_SENZ DDRC
#define PORT_SENZ PORTC
#define PIN_SENZ PINC

#define DDR_BRG DDRA
#define PORT_BRG PORTA

#define DDR_M DDRD
#define PORT_MOT PORTD

#define PIN_MOT_D_PWM PD5
#define PIN_MOT_D_IN1 PD6
#define PIN_MOT_D_IN2 PD7
#define SPEED_MOT_D OCR1AL

#define PIN_MOT_S_PWM PD4
#define PIN_MOT_S_IN1 PD3
#define PIN_MOT_S_IN2 PD2
#define SPEED_MOT_S OCR1BL


void init() 
{
	DDR_BRG = 0xFF;   
	DDR_SENZ = 0x00;   
	PORT_SENZ = 0xFF;   

	TCCR1A = 0x00;
	TCCR1B = 0x00;
	
	TCCR1A |= (1<<WGM10) | (1<<WGM11);
	TCCR1B |= (1<<WGM13);					
	
	TCCR1A |= (1<<COM1A1) | (1<<COM1B1);    
	
	TCCR1B |= (1<<CS12) | (1<<CS10);        

	DDR_M = 0xFF;					    
	PORT_MOT = 0x00;
	
}


int main(void)
{
	init();
	
	
	uint8_t sreg=SREG;
	
	int powerM_D, powerM_S;
	unsigned char x;
	int i;
	
	
    while(1)
    {
		PORT_MOT = 0x00;
		for(i = 0, x = 0; i < 8; ++i)
		{
			x |= ((((1 << i) & PIN_SENZ) >> i) << (7 - i));
		}
		
        PORT_BRG = x;
		
		cli();
			SPEED_MOT_D = 100;
			SPEED_MOT_S = 100;
		SREG=sreg;
		
		if(x - PIN_SENZ >= 16)
		{
				
				PORT_MOT = (1<<PIN_MOT_S_IN1);  
		}				
		else
		{
			if(PIN_SENZ - x >= 16)	
			{
					PORT_MOT = (1<<PIN_MOT_D_IN1);
			}
			else
			{
					PORT_MOT = (1<<PIN_MOT_D_IN1) | (1<<PIN_MOT_S_IN1);
			}	
		}			
	
		_delay_ms(50);
    }
}
